; ZINPT v1.4
; Kashan A. Shaikh
; 8/20/99
; email: kshaikh@vt.edu
; TI-83 homepage: http://www.angelfire.com/ri/kshaikh/
;-----------

.nolist
	.org	$0000

#include	"joeti83.inc"

#define	data	cmdshad+38	; 2 bytes of data
.list

	.dw	version		; version #
	.dw	waitkey 	; wait for key
	.dw	string		; get string input

;==========----------= Get Version =----------==========(LIB0)
;Input: nothing
;Output: h = major, l = minor
version:
	ld	hl,1*256+4
	ret

;=========--------= Wait for Keypress =--------=========(LIB1)
;Input: nothing
;Output: a = key value 
;	 z = 0 if any key besides [DEL] pressed 
;	 z = 1 if [DEL] pressed
waitkey:
	ei
loop1:	
	ld	a,($8001)
	or	a
	jr	nz,loop1		; wait for it to "clear out"
loop2:
	ld	a,($8001)
	or	a
	jr	z,loop2
	cp	56
	ret

;=========--------= Get String Input =---------=========(LIB2)
;Input: a = max length of string (Do not exceed 16*8)
;	b = 0 (clear the string up to max before writing...ex: highscore names),
;	    1 (edit string)
;	ix = location to store string
;Output: string is displayed to screen
;	 a = the length of the inputted string
;	 ix = byte of last character
string:
	ld	(data),a 			; store max length
	ld	a,b
	ld	(data+1),a			; 0=clear, 1=edit
	or	a
	jr	nz,edit
	
	ld	a,(data)
	ld	b,a
	ld	a,32				; space
	push	ix
clear_loop:
	ld	(ix),a				; clear string
	inc	ix
	djnz	clear_loop
	pop	ix

edit:	
	call	_getk				; reset

	res	2,(iy+13)			; DO NOT SCROLL!
	set	3,(iy+12)
	set	2,(iy+12)
		
	ld	hl,imathptr1			; -store a routine-
	ld	a,$E1				; pop hl
	ld	(hl),a
	inc	hl
	ld	a,$E5				; push hl
	ld	(hl),a
	inc	hl
	ld	a,$C9				; ret
	ld	(hl),a				; -----

	call	imathptr1
top_addr:	
	ld	de,-top_addr+end_flag
	add	hl,de
	xor	a
	ld	(hl),a
	
	ld      b,a				; ld b,0
string_loop:
	push 	bc
	call	_getk
	pop	bc
	or	a
	jr	z,string_loop
	push	bc
	call	_clrshd
	pop	bc
	cp	56
	jr	z,delete			; [DEL] pressed
	cp	15
	jr	z,clear_line_relay		; [CLEAR] pressed
	cp	1
	jr	z,down_arrow_relay		; down pressed
	cp	2
	jr	z,backup			; <- pressed
	cp	3
	jr	z,forward_relay			; -> pressed
	cp	4
	jr	z,up_arrow_relay		; up pressed
	cp	48
	jr	z,case_toggle_relay		; [ALPHA] pressed
	cp	9
	jr	z,userdone_relay		; [ENTER] pressed
	ld	c,a
	ld	a,(data)			; max length
	cp	b
	jr	z,string_loop
	call	imathptr1
getcase:
	ld	de,-getcase+case
	add	hl,de
	ld	a,(hl)
	dec	a
	jr	z,lblA_low
	call	imathptr1			; get address
lblA_up:
	ld	de,-lblA_up+char_strtable_UPPER-10
lblA_up2:
	add	hl,de
	ld	e,c
	ld	d,0
	add	hl,de
	ld	a,(hl)
	ld	(ix),a
lblA_up3:
	ld	d,a
	ld	a,(data)
	dec	a
	cp	b
	jr	z,lblA_up_end
	ld	a,d
	call	_putc	
	inc	ix
	inc      b
	jr	string_loop
lblA_up_end:
	ld	a,d
	call	_putmap
	call	imathptr1
A_pointer:
	ld	de,-A_pointer+end_flag
	add	hl,de
	ld	a,1
	ld	(hl),a	
	jr	string_loop

lblA_low:
	call	imathptr1
lblA_low2:
	ld	de,-lblA_low2+char_strtable_lower-10
	jr	lblA_up2

down_arrow_relay:
	jr	down_arrow
forward_relay:
	jr	forward
string_loop_relay:
	jr	string_loop
up_arrow_relay
	jr	up_arrow
case_toggle_relay
	jr	case_toggle_relay2

delete:
	ld	a,32
	ld	(ix),a
	call	_putmap
	jr	string_loop_relay

userdone_relay
	jr	userdone_relay2
clear_line_relay:
	jr	clear_line_relay2

backup: 
	xor	a
	cp	b
	jr	z,string_loop_relay
	ld	a,(ix)
	call	_putmap
	dec	b
	dec	ix
	ld	hl,curcol
	ld	a,(hl)
	or	a
	jr	z,newrow
	res	2,(iy+12)
	dec	(hl)
	set	2,(iy+12)
backup_2:
	ld	a,(ix)
	call	_putmap
	jr	string_loop_relay
newrow:
	ld	hl,currow
	dec	(hl)				; go up a row
	inc	hl
	ld	(hl),15				; go to column 15
	jr	backup_2

forward:
	ld	a,(data)			; max length
	dec	a
	cp	b
	jr	z,string_loop_relay
	ld	a,(ix)
	jr	lblA_up3

down_arrow:
	ld	a,(data)
	sub	33
	jr	c,string_loop_relay
	ld	hl,currow
	ld	a,(hl)
	cp	7
	jr	z,string_loop_relay
	ld	a,(ix)
	call	_putmap
	ld	hl,currow
	inc	(hl)
	ld	d,b
	ld	b,16
down_arrow_loop:
	inc	ix
	inc	d
	djnz	down_arrow_loop
	ld	b,d
string_loop_relay2:
	jr	string_loop_relay

case_toggle_relay2:
	jr	case_toggle
clear_line_relay2:
	jr	clear_line
userdone_relay2:
	jr	userdone

up_arrow:
	ld	a,(data)
	sub	33
	jr	c,string_loop_relay
	ld	hl,currow
	ld	a,(hl)
	or	a
	jr	z,string_loop_relay2
	ld	a,(ix)
	call	_putmap
	ld	hl,currow
	dec	(hl)
	ld	d,b
	ld	b,16
up_arrow_loop:
	dec	ix
	dec	d
	djnz	up_arrow_loop
	ld	b,d
	jr	string_loop_relay2

case_toggle:
	call	imathptr1
case_togglelbl:
	ld	de,-case_togglelbl+case
	add	hl,de
	ld	a,(hl)
	or	a
	jr	z,to_lower
to_upper:
	xor	a
	ld	(hl),a
	jr	string_loop_relay2
to_lower:
	inc	a
	ld	(hl),a
	jr	string_loop_relay2

clear_line:
	ld	hl,curcol
	ld	a,(hl)
	or	a
	jr	z,clear_next
clear_line_back:	
	dec	a
	dec	b
	dec	ix
	dec	(hl)
	ld	c,a
	ld	a,b
	or	a
	jr	z,clear_next
	ld	a,c
	or	a
	jr	nz,clear_line_back
clear_next:
	ld	d,b
	ld	b,a
	ld	a,16
	sub	b
	ld	b,a
	ld	a,(data)
	sub	b
	jr	c,clear_line_short
clear_line_aftershort:
	ld	e,b
clear_line_loop:
	ld	a,32
	ld	(ix),a
	call	_putmap
	inc	ix
	inc	(hl)
	djnz	clear_line_loop
	ld	b,e
clear_line_back_finish:
	dec	ix
	dec	(hl)
	djnz	clear_line_back_finish
	ld	b,d
	jr	string_loop_relay2
clear_line_short:
	ld	a,(data)
	ld	b,a
	jr	clear_line_aftershort

userdone:
	ld	a,(data+1)
	or	a
	jr	nz,ending_edit
	ld	a,b
	ld	(data+1),a
	call	imathptr1
userdone_addr:
	ld	de,-userdone_addr+end_flag
	add	hl,de
	ld	a,(hl)
	or	a
	jr	nz,ending
	ld	a,(data)
	sub	b			; string less than max
	ld	b,a
spaceloop:
	ld	(ix),32
	inc	ix
	djnz	spaceloop
ending:
	call	imathptr1
endinglbl:
	ld	de,-endinglbl+case
	add	hl,de
	xor	a
	ld	(hl),a
	res	2,(iy+12)
	res	3,(iy+12)
	call	_homeup
	set	2,(iy+13)		; ALLOW SCROLLING
	ld	a,(data+1)		; store length of string in A	
	ret

ending_edit:
	ld	a,b
	ld	(data+1),a
	jr	ending

end_flag:
	.db	0
case:
	.db	0
char_strtable_UPPER:
	.db     22h,"WRMH."
        .db     ".?",5Bh,"VQLG!.:ZUPKFC"	; character table
        .db     40h," YTOJEBX.XSNIDA"
        .db     ".",27h,2Fh,26h,29h,28h,".",2Ch
char_strtable_lower:
	.db	22h,"wrmh."
	.db	".?",5Bh,"vqlg!.:zupkfc"
	.db	40h," ytojebx.xsnida"
	.db	".",27h,2Fh,26h,29h,28h,".",2Ch

.end
END